use std::rc::Rc;
use std::sync::Arc;
use std::sync::Mutex;
use std::cell::RefCell;

#[cfg(test)]
mod tests {
    #[test]
    fn it_works() {
        let result = 2 + 2;
        assert_eq!(result, 4);
    }
}

pub trait SharedFromSelf {
    fn shared_from_self(&self) -> Rc::<RefCell::<Self>>;
}

pub trait SharedFromSelfLock {
    fn shared_from_self_lock(&self) -> Arc::<Mutex::<Self>>;
}

pub trait Singleton {
}
