use bytes::{BytesMut};

pub struct PackHead {

}

pub struct WSProxyPackHead_C {

}

pub struct WSProxyPackHead_S {

}

impl PackHead {

    pub fn get_size() -> u16 {
        return 12
    }

    pub fn get_pack_len(buf: &BytesMut, offset: usize) -> u16 {
        let pack_len = (buf[offset + 0] as u16)+ ((buf[offset + 1] as u16) << 8);
        return pack_len;
    }

    pub fn get_msg_id(buf: &BytesMut, offset: usize) -> u16 {
        let msg_id = (buf[offset + 2] as u16)+ ((buf[offset + 3] as u16) << 8);
        return msg_id;
    }

    pub fn get_seq_id(buf: &BytesMut, offset: usize) -> i32 {
        let seq_id = (buf[offset + 4] as i32)+ ((buf[offset + 5] as i32) << 8) +
            ((buf[offset + 6] as i32) << 16)+ ((buf[offset + 7] as i32) << 24);
        return seq_id;
    }

    pub fn get_magic_code(buf: &BytesMut, offset: usize) -> u16 {
        let magic_code = (buf[offset + 8] as u16)+ ((buf[offset + 9] as u16) << 8);
        return magic_code;
    }

    pub fn get_ext_len(buf: &BytesMut, offset: usize) -> u16 {
        let ext_len = (buf[offset + 10] as u16)+ ((buf[offset + 11] as u16) << 8);
        return ext_len;
    }

}

impl WSProxyPackHead_C {

    pub fn get_size() -> u16 {
        return 24;
    }

}
impl WSProxyPackHead_S {

    pub fn get_size() -> u16 {
        return 16;
    }

}
